% pp = raw.p;
% bb = raw.b;
% thr = raw.thr;

function [m1,bm1] = lower_part_pc(thr,pp,bb)

%beta = log(((1-pp(1:(end-1))).*thr(1:(end-1)).*bb(1:(end-1)))./((1-pp(2:end)).*thr(2:end).*bb(2:end)));
%beta1=beta(1);

beta1 = log(((1-pp(1)).*thr(1).*bb(1))./((1-pp(2)).*thr(2).*bb(2)));

%m1 = (pp(1)+pp(2))/2;
m1 = 0.999*pp(1)+0.001*pp(2);

pp_low = [pp(1); m1; pp(2); pp(3)];

f = @(p,bm1)(interp1(pp_low,[bb(1); bm1; bb(2); bb(3)],p,'pchip','extrap'));

f_beta = @(bm1)(quadgk(@(q)(1./((1-q).*f(q,bm1))),pp(1),pp(2),'MaxIntervalCount',10000));

bm_h = interp1(pp(1:3),bb(1:3),m1,'linear','extrap');
bm_l = interp1(pp(2:3),bb(2:3),m1,'linear','extrap');
bm_pchip = interp1(pp(1:3),bb(1:3),m1,'pchip','extrap');

if beta1>f_beta(bm_pchip)
%    g = @(t)(f_beta((1-t)*bm_pchip+t*bm_l))
    g = @(t,ll,hh)(f_beta((1-t)*hh+t*ll));
    
    delta = 0.01;
    ll_temp = bm_l;
    hh_temp = bm_pchip;
    temp = bm_pchip;
    
    while abs(f_beta(temp)-beta1)>1e-16
    t_loc=0;
    
    while g(t_loc,ll_temp,hh_temp)<beta1
        t_loc = t_loc+delta;
    end
    ll_temp0 = ll_temp;
    hh_temp0 = hh_temp;
    
    hh_temp = (1-(t_loc-delta))*hh_temp0+(t_loc-delta)*ll_temp0;
    ll_temp = (1-t_loc)*hh_temp0+t_loc*ll_temp0;
%    delta = delta/10
    if abs(f_beta(ll_temp)-beta1)<abs(f_beta(hh_temp)-beta1)
        temp = ll_temp
    else
        temp = hh_temp
    end
    end
    
    f_beta(temp)
    beta1
    abs(f_beta(temp)-beta1)
end

bm1 = temp;

pp_draw = linspace(0,1,10000);
bb_draw = ones(1,10000);
bb_draw((pp_draw>=pp(1))&(pp_draw<=pp(3))) = f(pp_draw((pp_draw>=pp(1))&(pp_draw<=pp(3))),bm1);

plot(pp_draw,bb_draw)
hold on
scatter(pp(1:3),bb(1:3))